<template>
  <div class="dashboard">
    <div class="wp-title wp-12">Панель управления</div>
    <masonry class="wp-12"
      :columnClass="MasonryColumnClass"
      :cols="MasonryColumns"
      :gutter="MasonryGutter">
      <card title="Основная информация" edit>
        <template #default="{ isEditing }">
          <card-form :fields="mainInfoCardFields" :data="organization" :readOnly="!isEditing"
            submitText="Изменить название" :submitFunction="updateOrganizationSettings"/>
        </template>
      </card>
      <card title="Основные функции" v-if="!organization.categories_enabled && baseCategory">
        <div class="wp-layout">
          <wp-input class="wp-6" type="switch"
            v-model="baseCategoryAllowNegative" label="Отрицательные оценки"/>
        </div>
      </card>
      <card title="Модули" edit>
        <template #default="{ isEditing }">
          <card-form :fields="modulesCardFields" :data="organization" :readOnly="!isEditing"
            submitText="Изменить активные модули" :submitFunction="updateOrganizationSettings"/>
        </template>
      </card>
    </masonry>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';

import { MasonryGutter, MasonryColumnClass, MasonryColumns } from '@/shared';

import Card from '@/components/Card.vue';
import CardForm from '@/components/card/CardForm.vue';
import WpInput from '@/components/WpInput.vue';

export default {
  name: 'OrganizationDashboard',
  components: {
    Card,
    CardForm,
    WpInput,
  },
  data() {
    return {
      MasonryGutter,
      MasonryColumns,
      MasonryColumnClass,
      mainInfoCardFields: [{
        type: 'text',
        prop: 'name',
        label: 'Название организации',
      }],
      modulesCardFields: [{
        type: 'switch',
        prop: 'categories_enabled',
        label: 'Категории',
        span: 6,
      }, {
        type: 'switch',
        prop: 'reasons_enabled',
        label: 'Причины',
        span: 6,
      }, {
        type: 'switch',
        prop: 'teamplay_enabled',
        label: 'Команды',
        span: 6,
        disabled: true,
      }, {
        type: 'switch',
        prop: 'statistics_enabled',
        label: 'Статистика',
        span: 6,
      }, {
        type: 'switch',
        prop: 'market_enabled',
        label: 'Магазин',
        span: 6,
        disabled: true,
      }, {
        type: 'switch',
        prop: 'achievements_enabled',
        label: 'Достижения',
        span: 6,
        disabled: true,
      }],
    };
  },
  computed: {
    ...mapState('organization', ['organization']),
    ...mapGetters('organization', ['baseCategory']),
    baseCategoryAllowNegative: {
      async set(allowNegative) {
        try {
          await this.updateCategory({
            id: this.baseCategory.id,
            allow_negative: allowNegative,
          });
        } catch (errors) {
          if (errors.length) {
            errors.forEach((err) => {
              this.$toasted.error(err.message);
            });
          } else {
            this.$toasted.error('Неизветсная ошибка');
          }
        }
      },
      get() {
        return this.baseCategory ? this.baseCategory.allow_negative : false;
      },
    },
  },
  methods: {
    ...mapActions('organization', [
      'getOrganizationCategories',
      'updateOrganizationSettings',
      'updateCategoriesEnabled',
      'updateReasonsEnabled',
      'updateTeamplayEnabled',
      'updateCategory',
    ]),
  },
  created() {
    this.getOrganizationCategories();
  },
};
</script>

<style lang="scss" scoped>
</style>
